VERSION 5.00
Begin VB.Form BackerForm 
   Caption         =   "Backer"
   ClientHeight    =   3045
   ClientLeft      =   270
   ClientTop       =   555
   ClientWidth     =   3765
   ClipControls    =   0   'False
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3045
   ScaleWidth      =   3765
   WindowState     =   1  'Minimized
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete"
      Default         =   -1  'True
      Height          =   495
      Left            =   1920
      TabIndex        =   13
      Top             =   2520
      Width           =   855
   End
   Begin VB.CommandButton cmdEdit 
      Caption         =   "Edit"
      Height          =   495
      Left            =   960
      TabIndex        =   12
      Top             =   2520
      Width           =   855
   End
   Begin VB.ComboBox cboStyle 
      Height          =   315
      ItemData        =   "Backer.frx":0000
      Left            =   960
      List            =   "Backer.frx":000D
      Style           =   2  'Dropdown List
      TabIndex        =   11
      Top             =   360
      Width           =   1695
   End
   Begin VB.PictureBox HiddenPict 
      AutoSize        =   -1  'True
      Height          =   375
      Left            =   3240
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   8
      Top             =   0
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   495
      Left            =   960
      TabIndex        =   7
      Top             =   1680
      Width           =   855
   End
   Begin VB.Timer SwitchTimer 
      Enabled         =   0   'False
      Interval        =   30000
      Left            =   2760
      Top             =   0
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   495
      Left            =   1920
      TabIndex        =   6
      Top             =   1680
      Width           =   855
   End
   Begin VB.TextBox DirText 
      Height          =   285
      Left            =   0
      TabIndex        =   5
      Top             =   1320
      Width           =   3735
   End
   Begin VB.TextBox SecsText 
      Height          =   285
      Left            =   2040
      MaxLength       =   5
      TabIndex        =   3
      Text            =   "300"
      Top             =   -15
      Width           =   615
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "Apply"
      Height          =   495
      Left            =   0
      TabIndex        =   1
      Top             =   1680
      Width           =   855
   End
   Begin VB.CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   495
      Left            =   2880
      TabIndex        =   0
      Top             =   1680
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Style"
      Height          =   255
      Index           =   2
      Left            =   0
      TabIndex        =   10
      Top             =   360
      Width           =   735
   End
   Begin VB.Label FileLabel 
      Alignment       =   2  'Center
      Height          =   195
      Left            =   0
      TabIndex        =   9
      Top             =   2280
      Width           =   3765
   End
   Begin VB.Label Label1 
      Caption         =   "Picture directory"
      Height          =   255
      Index           =   1
      Left            =   0
      TabIndex        =   4
      Top             =   960
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Seconds between pictures"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   1935
   End
End
Attribute VB_Name = "BackerForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByVal lpvParam As Any, ByVal fuWinIni As Long) As Long
Private Const SPI_SETDESKWALLPAPER = 20
Private Const SPIF_UPDATEINIFILE = 1

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL = 1
Private Const SW_SHOWMAXIMIZED = 3

Private Pause As Long
Private DirName As String
Private NextTime As Date
Private UpdateRegistry As Boolean

Private Const APP_NAME = "Backer"
Private Const SECTION_NAME = "Backer"

Private FileNames As Collection
Private NumNames As Integer
Private Indexes() As Integer
Private NextIndex As Integer

Private m_CurrentFile As String

' ************************************************
' Get the current configuration values.
' ************************************************
Public Sub LoadConfig()
Dim txt As String * 256
Dim strlen As Long

    Pause = GetSetting(APP_NAME, SECTION_NAME, _
        "Interval", "300")
    
    DirName = GetSetting(APP_NAME, SECTION_NAME, _
        "DirName", "C:\")

    UpdateRegistry = GetSetting(APP_NAME, SECTION_NAME, _
        "UpdateRegistry", False)

    cboStyle.Text = GetSetting(APP_NAME, SECTION_NAME, _
        "Style", "Tiled")

    On Error Resume Next
    If Dir(DirName & "\*.*") = "" Then _
        DirName = "C:\"
End Sub

' ************************************************
' Save the current configuration values.
' ************************************************
Public Sub SaveConfig()
    SaveSetting APP_NAME, SECTION_NAME, _
        "Interval", Format$(Pause)
    SaveSetting APP_NAME, SECTION_NAME, _
        "DirName", DirName
    SaveSetting APP_NAME, SECTION_NAME, _
        "UpdateRegistry", UpdateRegistry
    SaveSetting APP_NAME, SECTION_NAME, _
        "Style", cboStyle.Text
End Sub

Private Sub RandomizeNames()
Dim idx As Integer
Dim tmp As Integer
Dim i As Integer

    ReDim Indexes(1 To NumNames)
    For i = 1 To NumNames
        Indexes(i) = i
    Next i

    ' Randomize them.
    For i = 1 To NumNames - 1
        idx = Int((NumNames - i + 1) * Rnd + i)
        tmp = Indexes(i)
        Indexes(i) = Indexes(idx)
        Indexes(idx) = tmp
    Next i
    
    ' Point to the index to display.
    NextIndex = 1
End Sub

' Delete the current file.
Private Sub cmdDelete_Click()
    ' Delete the file.
    DeleteFile m_CurrentFile, False

    ' Display the next file.
    cmdNext_Click
End Sub

' Edit the file.
Private Sub cmdEdit_Click()
    ShellExecute ByVal 0&, "edit", m_CurrentFile, _
        vbNullString, vbNullString, SW_SHOWMAXIMIZED
End Sub

' Display the next image.
Private Sub cmdNext_Click()
    NextTime = Now
    SwitchTimer_Timer
End Sub

' ************************************************
' Load the next picture.
' ************************************************
Private Sub SwitchTimer_Timer()
Dim secs As Long
Dim pic As Integer

    ' See if it's time yet.
    secs = DateDiff("s", Now, NextTime)
    If secs <= 1 Then
        If FileNames.Count > 1 Then
            pic = Indexes(NextIndex)
            NextIndex = NextIndex + 1
            If NextIndex > NumNames Then RandomizeNames

            ShowFile FileNames(pic)
        End If
        NextTime = DateAdd("s", Pause, Now)
        secs = Pause
    End If
    
    If secs <= 60 Then
        SwitchTimer.Interval = secs * 1000
    Else
        SwitchTimer.Interval = 60000
    End If
    SwitchTimer.Enabled = True
End Sub

' Display this file.
Private Sub ShowFile(ByVal file_name As String)
Const STYLE_CENTERED As String = "0"
Const STYLE_TILED As String = "1"
Const STYLE_STRETCHED As String = "2"
Const TILE_NO As String = "0"
Const TILE_YES As String = "1"

Dim had_error As Boolean

    ' Set the display style.
    had_error = False
    Select Case cboStyle.Text
        Case "Centered"
            If SetRegistryValue(HKEY_CURRENT_USER, _
                "Control Panel\Desktop", "TileWallpaper", TILE_NO) _
                    Then had_error = True
            If SetRegistryValue(HKEY_CURRENT_USER, _
                "Control Panel\Desktop", "WallpaperStyle", STYLE_CENTERED) _
                    Then had_error = True
        Case "Tiled"
            If SetRegistryValue(HKEY_CURRENT_USER, _
                "Control Panel\Desktop", "TileWallpaper", TILE_YES) _
                    Then had_error = True
            If SetRegistryValue(HKEY_CURRENT_USER, _
                "Control Panel\Desktop", "WallpaperStyle", STYLE_TILED) _
                    Then had_error = True
        Case "Stretched"
            If SetRegistryValue(HKEY_CURRENT_USER, _
                "Control Panel\Desktop", "TileWallpaper", TILE_NO) _
                    Then had_error = True
            If SetRegistryValue(HKEY_CURRENT_USER, _
                "Control Panel\Desktop", "WallpaperStyle", STYLE_STRETCHED) _
                    Then had_error = True
    End Select
    If had_error Then
        MsgBox "Error saving desktop style to registry.", _
            vbOKOnly, "Registry Error"
    End If

    ' Display the file.
    FileLabel.Caption = file_name
    m_CurrentFile = DirName & "\" & file_name
    If UCase$(Right$(file_name, 4)) = ".BMP" Then
        SystemParametersInfo SPI_SETDESKWALLPAPER, _
            0, m_CurrentFile, SPIF_UPDATEINIFILE
    Else
        HiddenPict.Picture = LoadPicture(m_CurrentFile)
        SavePicture HiddenPict.Picture, DirName & "\temp.bmp"
        SystemParametersInfo SPI_SETDESKWALLPAPER, _
            0, DirName & "\temp.bmp", _
            SPIF_UPDATEINIFILE
    End If
End Sub

Private Sub cmdEnd_Click()
    End
End Sub
Private Sub cmdHelp_Click()
Dim txt1 As String
Dim txt2 As String
    
    txt1 = """Seconds between pictures"" is the time the program waits between displaying pictures. This value must be between 1 and 60."
    txt2 = """Picture directory"" tells the program where to look for pictures. This directory should contain the .BMP files you want to display."
    MsgBox txt1 & vbCrLf & vbCrLf & txt2, _
        vbInformation
End Sub
Private Sub cmdApply_Click()
    ' Save the values.
    On Error Resume Next
    Pause = CInt(SecsText.Text)
    If Pause < 1 Then Pause = 1
    SecsText.Text = Format$(Pause)
    SwitchTimer.Enabled = False
    NextTime = Now
    
    DirName = DirText.Text
    
    ' Read the files in the directory.
    ReadFiles
    
    ' Save the new settings.
    SaveConfig
    
    ' Apply the new settings.
    SwitchTimer_Timer
End Sub
' *********************************************
' Read the names of the files in the directory.
' *********************************************
Sub ReadFiles()
Dim file As String
Dim ext As String

    ' Create the new file name collection.
    Set FileNames = New Collection
    
    ' Get the file names.
    file = Dir(DirName & "\*.*")
    Do While file <> ""
        If LCase$(file) <> "temp.bmp" Then
            ext = UCase$(Right$(file, 4))
            If ext = ".BMP" Or ext = ".GIF" Or _
               ext = ".JPG" Or ext = "JPEG" _
               Then _
                    FileNames.Add file
        End If
        file = Dir()
    Loop
    
    NumNames = FileNames.Count
    RandomizeNames
End Sub
Private Sub Form_Load()
    ' Move to (0, 0).
    Move 0, 0

    ' Initialize the random number generator.
    Randomize
    
    ' Fill in the saved values.
    LoadConfig
    SecsText.Text = Format$(Pause)
    DirText.Text = DirName

    ' Draw the first picture.
    cmdApply_Click
End Sub
